/*
 * Nested scopes.
 *
 * David Leonard, 2001. Public domain.
 */

#include <stdio.h>
#include <stdlib.h>
#include "hash.h"
#include "scope.h"

void
scope_undefine(s, name)
	scope_t *s;
	char *name;
{
	hash_del(s->hash, name);
}

int
scope_define(s, name, value)
	scope_t *s;
	char *name;
	char *value;
{
	return hash_put(s->hash, name, value);
}

char *
scope_lookup(s, name)
	scope_t *s;
	char *name;
{
	char *result;
	while (s) {
		result = hash_get(s->hash, name);
		if (result != NULL)
			return result;
		s = s->outer;
	}
	return NULL;
}

scope_t *
new_scope()
{
	scope_t *s = (scope_t *)malloc(sizeof (scope_t));

	s->hash = new_hash();
	return s;
}

void
free_scope(s)
	scope_t *s;
{
	free_hash(s->hash);
	free(s);
}

