
struct chr {
	int len;
	char *data;
};

typedef struct {
	enum type { UNK, ANY, LOG, INT, CHR } v_type;
	union {
		char	u_log;
		int	u_int;
		struct chr u_chr;
	} v_u;
#define v_log	v_u.u_log
#define v_int	v_u.u_int
#define v_dec	v_u.u_dec
#define v_chr	v_u.u_chr
} value_t;

typedef struct values {
	value_t val;
	struct values *next;
} values_t;

/* Should always free values in case they are CHR */
#define value_free(v) \
	do {							\
		if ((v).v_type == CHR && (v).v_chr.len != 0) {	\
			free((v).v_chr.data);			\
			(v).v_chr.len = 0;			\
			(v).v_chr.data = "";			\
		}						\
	} while(0)
